<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Export
 */


if ( $_SESSION['UserRechte'] < 300 )
    exit();

if ( $myVar->MenuID == 293 && isset($_REQUEST['sent']) )
{
    // Datum einsetzen, falls es erfordert wird
    $settings->exportName = str_replace( "DATUM", date("Y-m-d"), $settings->exportName );
    
    if ( $_GET['export'] == 1 || $_GET['export'] == 2 )
        $settings->exportName .= ".pdf";
    else
        $settings->exportName .= ".csv";
    
    // zerlege den Namen in Verzeichnisse
    $fileArray = explode( "/", $settings->exportName );
    $FileName = $fileArray[count($fileArray)-1];
    
    // Falls kein Verzeichnis vorhanden, wird eine temporre Datei erstellt
    if ( count($fileArray) == 1 )
        $tmpfname = tempnam("/tmp", $FileName);
    else
        $tmpfname = $settings->exportName;
    
	if ( !$fp = fopen($tmpfname,'wb') )
        $myVar->warnung[] = "Fehler beim Erstellen einer tempor&auml;reren Datei! Evtl. hilft ein anderer Exportname (siehe Settings).";
    else
    {
        
        // Vor Ausgeben der Daten einen Puffer ffnen
        ob_start();
        
        if ( $_GET['export'] == 1 || $_GET['export'] == 2 )
        {
        	// PDF-Handler mit Daten fllen
            $pdf =& new Cezpdf();
            $pdf->selectFont('./classes/pdf_fonts/Helvetica.afm');
            $pdf->ezSetCmMargins(1.5,1.5,1.5,1.5);
            
            $sql = "SELECT * FROM $myDB->FILME fi WHERE $myDB->sqlForPriv";
            
            // Wie wird sortiert?
            if ( $_GET['export'] == 1 )
                $sql .= " ORDER BY Titel";
            else if ( $_GET['export'] == 2 )
                $sql .= " ORDER BY COLLECT_CollectID, FilmID";
            
            //$sql .= " LIMIT 2";
            
            // Ausgabe in den Handler schreiben 
            $rs = $myDB->go($sql);
            while ( $row = $myDB->getRow($rs) )
            {
                /*
                $sql2 = "SELECT * FROM $myDB->COVERS WHERE FILME_FilmID={$row['FilmID']} AND hatThumbnail=1";
                $rs2 = $myDB->go($sql2);
                $row2 = $myDB->getRow($rs2);
                $thumb = "$cover_dir/".$row2['FILME_FilmID']."_".$row2['Rang']."_".$row2['Appendix']."_small.".$row2['Extension'];
                
                $pdf->ezImage( $thumb, 5, 0, 'none', 'left' );
                */
                $ID = $row['COLLECT_CollectID']."-".getAnzStellenID($row['myFilmID'], $settings);
                $pdf->ezText( "<b>".ret_entities($row['Titel'])."</b> ($ID)" ,9 );
                $pdf->ezText( "\n",1 );
                $pdf->ezText( ret_entities($row['Land'])." / ".$row['Jahr']." - ".ret_entities(getName("Genre", $row['FilmID'], $myDB, $settings ) ) ,8 );
                $pdf->ezText( "\n",1 );
                $pdf->ezText( "Regisseur: ".ret_entities( getName("Regisseure", $row['FilmID'], $myDB, $settings ) ) ,8 );
                $pdf->ezText( "\n",1 );
                $pdf->ezText( "Schauspieler: ".ret_entities( getName("Actors", $row['FilmID'], $myDB, $settings ) ) ,8 );
                $pdf->ezText( "\n",1 );
                $pdf->ezText( ret_entities( str_replace( "<br />", "", $row['Inhalt'] ) ), 8 );
                $pdf->ezText( "\n",4 );
            }
            $pdf->ezStream();
        }
        else
        {
            echo "Film;FilmID;DiscID;Land;Format;Kollektion;Jahr;FSK;Laufzeit;Genre;Regisseur;Schauspieler;\n\n";
            
            $sql = "SELECT FilmID,myFilmID,Titel,COLLECT_CollectID,FORMATE_FormatID,Land,Jahr,FSK,Laufzeit,fo.Bezeichnung AS foName, co.Bezeichnung AS coName FROM $myDB->FILME fi INNER JOIN $myDB->COLLECT co ON COLLECT_CollectID=CollectID INNER JOIN $myDB->FORMATE fo ON FORMATE_FormatID=FormatID WHERE $myDB->sqlForPriv ORDER BY Titel";
            $rs = $myDB->go($sql);
            while ( $row = $myDB->getRow($rs) )
            {
                echo export_convert( $row['Titel'] );
                
                $ID = $row['COLLECT_CollectID']."-".getAnzStellenID($row['myFilmID'], $settings);
                echo export_convert( $ID);
                
                $ID = getDiscID ( $row['FilmID'], $myDB, $settings );
                echo export_convert( $ID );
                
                echo export_convert( $row['Land'] );
                echo export_convert( $row['foName'] );
                echo export_convert( $row['coName'] );
                echo export_convert( $row['Jahr'] );
                echo export_convert( $row['FSK'] );
                echo export_convert( $row['Laufzeit'] );
                echo export_convert( getName("Genre", $row['FilmID'], $myDB, $settings ) );
                echo export_convert( getName("Regisseure", $row['FilmID'], $myDB, $settings ) );
                echo export_convert( getName("Actors", $row['FilmID'], $myDB, $settings ) );
                
                echo "\n";
            }
        }
        
        
        // Alle Ausgaben stehen nun im Puffer
        $buffer = ob_get_clean();
        
        if (true){
        // Puffer in Datei schreiben
    	fwrite($fp,$buffer);
    	fclose($fp);
        
        // Datei zum Download ffnen
        header("Pragma: public");
    	header("Expires: 0");
    	header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
        if ( $_GET['export'] == 1 || $_GET['export'] == 2 )
           header("Content-Type: application/pdf");
        else
    	   header("Content-Type: application/octet-stream");
    	header("Content-Disposition: attachment; filename=\"$FileName\"");
    	header("Content-Description: File Transfer");
        header("Content-Length: ".filesize($tmpfname));
    	header("Accept-Ranges: bytes");
    	readfile($tmpfname);
        
    	exit();
        }
    }
}


?>
