<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Alles was mit Discverwaltung zu tun hat!
 */


if ( $_SESSION['UserRechte'] < 600 )
    exit();

if ( $myVar->MenuID == 591 && isset($_POST['sent']) && $_SESSION['UserRechte'] > 600 )
{
    // anzDisks kontrollieren
    if ( isset($_REQUEST['anzDisks']) )
    {
        if ( (int)$_REQUEST['anzDisks'] >= 1 && (int)$_REQUEST['anzDisks'] <= 16 ) // 16 ist sehr hoch
            $anzDisks = (int)$_REQUEST['anzDisks'];
        else
            $myVar->warnung[] = "Fehler in der Diskanzahl!";
    }
    
    // lese DiskID aus
    if ( isset($_POST['DiscID']) )
    {
        $DiscID = explode( "-", $_POST['DiscID'] );
        if ( count($DiscID) != 2 )
            $myVar->warnung[] = "Fehler in der DiscID!";
        else
        {
            $DiscID[0] = (int)$DiscID[0];
            $DiscID[1] = (int)$DiscID[1];
            
            if ( $DiscID[0]==0 || $DiscID[1]==0 )
                $myVar->warnung[] = "Fehler in der DiscID!";
            else
            {
                $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME INNER JOIN $myDB->DISCS ON FILME_FilmID=FilmID WHERE COLLECT_CollectID={$DiscID[0]} AND DiscID={$DiscID[1]}";
                $rs = $myDB->go($sql);
                $row = $myDB->getRow($rs);
                if( $row['Anz'] <= 0 )
                    $myVar->warnung[] = "Diese DiscID existiert nicht!";
            }
        }
    }
    if ( isset($_POST['newDiscID']) )
    {
        $newDiscID = explode( "-", $_POST['newDiscID'] );
        if ( count($newDiscID) != 2 )
            $myVar->warnung[] = "Fehler in der neuen DiscID!";
        else
        {
            $newDiscID[0] = (int)$newDiscID[0];
            $newDiscID[1] = (int)$newDiscID[1];
            
            if ( $newDiscID[0]==0 || $newDiscID[1]==0 )
                $myVar->warnung[] = "Fehler in der neuen DiscID!";
            else
            {
                $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME INNER JOIN $myDB->DISCS ON FILME_FilmID=FilmID WHERE COLLECT_CollectID={$newDiscID[0]} AND DiscID={$newDiscID[1]}";
                $rs = $myDB->go($sql);
                $row = $myDB->getRow($rs);
                if ( $newDiscID[0] != $DiscID[0] )
                    $myVar->warnung[] = "Die DiscID's m&uuml;ssen die gleiche KollektionsID besitzen!";
                elseif( $row['Anz'] > 0 )
                    $myVar->warnung[] = "Die neue DiscID (".$newDiscID[0]."-".getAnzStellenID($newDiscID[1],$settings).") existiert bereits!";
            }
        }
    }
    if ( isset($_POST['DiscID']) && isset($_POST['myFilmID']) )
        if ( $myVar->myFilmID[0] != $DiscID[0] )
            $myVar->warnung[] = "Die FilmID und DiscID m&uuml;ssen die gleiche KollektionsID besitzen!";
    
    
    // Film zu einer Disc hinzufgen
    if ( isset($_POST['addToDisc']) && !count($myVar->warnung) )
    {
        $sql = "INSERT INTO $myDB->DISCS (FILME_FilmID,DiscID) VALUES ($myVar->FilmID,{$DiscID[1]})";
        $myDB->go($sql);
        
        $myVar->erfolg[] = "Es wurde der Film ".$myVar->myFilmID[0]."-".getAnzStellenID($myVar->myFilmID[1],$settings)." zur Disk ".$myVar->myFilmID[0]."-".getAnzStellenID($DiscID[1],$settings)." hinzugef&uuml;gt.";
    }
    
    // Disc(s) zu einem Film hinzufgen
    if ( isset($_POST['addToFilm']) && !count($myVar->warnung) )
    {
        if ( $settings->firstFitID )
        {
            $sql = "SELECT DISTINCT di.DiscID FROM $myDB->DISCS di INNER JOIN $myDB->FILME fi ON di.FILME_FilmID = fi.FilmID WHERE fi.COLLECT_CollectID = ".$myVar->myFilmID[0]." ORDER BY DiscID ASC";
            $rs = $myDB->go($sql);
            $oldID = 1;
            $check = FALSE;
                
            // es wird gesucht, wo anzDisks hintereinander frei sind
            while ( $row = $myDB->getRow($rs) )
                if ( $oldID < $row['DiscID'] || $check )
                {
                    // am Anfang markieren, dass freie DiscID gefunden wurde
                    if ( !$check )
                        $check = TRUE;
                    // wenn Differenz von nchste belegte ID und gemerkte freie ID >= Anzahl ist, dann ID gefunden
                    elseif ( $row['DiscID']-$oldID > $anzDisks )
                        break;
                    // ansonsten Markierung rckgngig machen
                    else
                    {
                        $check = FALSE;
                        $oldID = $row['DiscID'] + 1;
                    }
                }
                else
                    ++$oldID;
                    
                $myDiscID = $oldID;
        }
        else // !$firstFitID
        {
            $sql = "SELECT MAX(DiscID)+1 AS DiscID FROM $myDB->DISCS INNER JOIN $myDB->FILME ON FILME_FilmID=FilmID WHERE COLLECT_CollectID=".$myVar->myFilmID[0];
            $rs = $myDB->go($sql);
            $row = $myDB->getRow($rs);
            $myDiscID = $row['DiscID'];
        }
            
        for ( $i = 0; $i < $anzDisks; ++$i )
        {
            $id = $myDiscID+$i;
            $sql = "INSERT INTO $myDB->DISCS (DiscID,FILME_FilmID) VALUES (".$id.",$myVar->FilmID)";
            $myDB->go($sql);
        }
        
        $myVar->erfolg[] = "Es wurde(n) $anzDisks Disk(s) zu ".$myVar->myFilmID[0]."-".getAnzStellenID($myVar->myFilmID[1],$settings)." hinzugef&uuml;gt.";
    }
    
    // Disc zu einem Film lschen
    if ( isset($_POST['delDisc']) && !count($myVar->warnung) )
    {
        $sql = "DELETE FROM $myDB->DISCS WHERE FILME_FilmID=$myVar->FilmID AND DiscID={$DiscID[1]} LIMIT 1";
        $myDB->go($sql);
        
        $myVar->erfolg[] = "Zu dem Film ".$myVar->myFilmID[0]."-".getAnzStellenID($myVar->myFilmID[1],$settings)." wurde Disk ".$myVar->myFilmID[0]."-".getAnzStellenID($DiscID[1],$settings)." gel&ouml;scht.";
    }
    
    // Disc zumbenennen
    if ( isset($_POST['renameDisc']) && !count($myVar->warnung) )
    {
        $sql = "SELECT FilmID FROM $myDB->FILME INNER JOIN $myDB->DISCS ON FILME_FilmID=FilmID WHERE COLLECT_CollectID={$DiscID[0]} AND DiscID={$DiscID[1]}";
        $rs = $myDB->go($sql);
        while ( $row = $myDB->getRow($rs) )
        {
            $sql2 = "UPDATE $myDB->DISCS SET DiscID={$newDiscID[1]} WHERE FILME_FilmID={$row['FilmID']} AND DiscID={$DiscID[1]}";
            $myDB->go($sql2);
        }
        $myVar->erfolg[] = "Die Disk ".$DiscID[0]."-".getAnzStellenID($DiscID[1],$settings)." hei&szlig;t nun ".$newDiscID[0]."-".getAnzStellenID($newDiscID[1],$settings)." gel&ouml;scht.";
    }
}

?>
