<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * RESET-Skript
 */


if ( !isset($_POST['sent']) )
{
    echo "<form method=\"post\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<input type=\"submit\" name=\"sent\" value=\"reset\">";
    echo "</form>";
}


if ( isset($_POST['sent']) )
{

require("../includes/functions.php");
require("../classes/class.db.php");
require("../classes/class.settings.php");
require("../settings/admin.php");

$myDB = new db($server, $username, $pass, $dbase, $prefix,$MySQL_Ver);
$settings = new settings( $myDB );


// Pfad zu den zu kopierende Covers
$covers = "./testcovers";


// Array mit Filmen, die kopiert werden sollen
$anzFilme = 10;


// alte Cover lschen
$sql = "SELECT * FROM $myDB->COVERS ORDER BY FILME_FilmID";
$rs = $myDB->go($sql);
while ( $row = $myDB->getRow($rs) )
{
    $filename = "../covers/".$row['FILME_FilmID']."_".$row['Rang']."_".$row['Appendix'].".".$row['Extension'];
    @unlink($filename);
    if ( $row['hatThumbnail'] )
    {
        $filename = "../covers/".$row['FILME_FilmID']."_".$row['Rang']."_".$row['Appendix']."_small.".$row['Extension'];
        @unlink($filename);
    }
    
}


// alte Loginzahlen merken
$sql = "SELECT anzLogin,lastLogin FROM $myDB->USERS ORDER BY UserID";
$rs = $myDB->go($sql);
$row = $myDB->getRow($rs);
$anzLogin[1] = (int) $row['anzLogin'];
$lastLogin[1] = $row['lastLogin'];
$row = $myDB->getRow($rs);
$anzLogin[2] = (int) $row['anzLogin'];
$lastLogin[2] = $row['lastLogin'];


// vorhande Tabellen lschen
$sql = "DROP TABLE $myDB->ACTORS, $myDB->COLLECT, $myDB->COVERS, $myDB->DISCS, $myDB->FILME, $myDB->FILME_ACTORS, $myDB->FILME_GENRES, $myDB->FILME_REGISSEURE, $myDB->FILME_USERS, $myDB->FORMATE, $myDB->GENRES, $myDB->REGISSEURE, $myDB->USERS;";
$rs = $myDB->go($sql);


// neue Tabellen erstellen
$array = file("../install/install_dabamodell.sql");
for ( $i = 0; $i < count($array); ++$i )
{
    $sql = str_replace( "PREFIX_", $prefix, $array[$i] );
    $myDB->go($sql);
}


// neue User mit alten Loginzahlen einfgen
$sql = "INSERT INTO $myDB->USERS (UserID,UserName,UserRechte,Email,PWD,anzLogin,lastLogin) VALUES (1,'Testadmin',900,'testadmin@der-domi.de',PASSWORD('passwort'),{$anzLogin[1]},'{$lastLogin[1]}')";
$rs = $myDB->go($sql);
$sql = "INSERT INTO $myDB->USERS (UserID,UserName,UserRechte,Email,PWD,anzLogin,lastLogin) VALUES (2,'Testuser',300,'testuser@der-domi.de',PASSWORD('passwort'),{$anzLogin[2]},'{$lastLogin[2]}')";
$rs = $myDB->go($sql);

// neue Zufallsuser generieren
for ( $i=1; $i<=15; ++$i )
{
    $zahl = (string) $i;
    if ( strlen($zahl) == 1 )
        $zahl = "0".$zahl; 
    $sql = "INSERT INTO $myDB->USERS ( UserName,Email,PWD ) VALUES ( \"ZufallsUser{$zahl}\", \"zufallsemail{$zahl}@der-domi.de\", PASSWORD(\"".gen_string()."\") )";
    $myDB->go($sql);
}


// neue Formate einfgen
$sql = "INSERT INTO $myDB->FORMATE (Bezeichnung) VALUES ('DVD')";
$rs = $myDB->go($sql);
$sql = "INSERT INTO $myDB->FORMATE (Bezeichnung,istStandard) VALUES ('DVD-9',1)";
$rs = $myDB->go($sql);
$sql = "INSERT INTO $myDB->FORMATE (Bezeichnung) VALUES ('DVD-12')";
$rs = $myDB->go($sql);


// neue Kollektion einfgen
$sql = "INSERT INTO $myDB->COLLECT (Bezeichnung,istStandard) VALUES ('im Wohnzimmer',1)";
$rs = $myDB->go($sql);
$sql = "INSERT INTO $myDB->COLLECT (Bezeichnung) VALUES ('im Arbeitszimmer')";
$rs = $myDB->go($sql);
$sql = "INSERT INTO $myDB->COLLECT (Bezeichnung) VALUES ('im Schlafzimmer')";
$rs = $myDB->go($sql);


// Genres einfgen
$GenArray = array('Action','Dokumentation','Drama','Horror','Krimi','Science Fiction','Thriller','Western','Anime');
for ( $i = 0; $i < count($GenArray); ++$i )
{
    $sql2 = "INSERT INTO $myDB->GENRES (Name) VALUES ('{$GenArray[$i]}')";
    $myDB->go($sql2);
}



// Namenliste fr Regisseure und Schauspieler ersellen
$namearray = array();
$namestring = "";
$array = file("./reset_namen.txt");
for ( $i = 0; $i < count($array); ++$i )
{
    $string = $array[$i]; //substr( $array[$i], 6, strlen($array[$i])-7 );
    //$string = str_replace( " / ", ", ", $string );
    $namestring .= $string.", ";
}

unset($array);
$array = array();
// String am Trennzeichen trennen
$namearray = explode( ",", $namestring );
// fr jeden Teil Leerzeichen entfernen und HTML-Entities ersetzen
for ( $i = 0; $i < count($namearray); ++$i )
    $array[$i] =  trim( htmlentities( $namearray[$i] ) );

// Namen vervielfltigen
$newnamearray = array();
for ( $i = 0; $i < count($namearray)-2; ++$i )
{
    for ( $j = 1; $j <= 2; ++$j )
        $newnamearray[] = $myDB->escape_string( $array[$i].$j );
}
// und einfgen
$id = getArrayNameID( $newnamearray, "Actors", $myDB );

$sql = "SELECT COUNT(*) AS Anz FROM $myDB->ACTORS";
$rs = $myDB->go($sql);
$row = $myDB->getRow($rs);
$anzActors = $row['Anz'];


// Filme generieren
for ( $i = 1; $i <= $anzFilme; ++$i )
{
    $fsk = rand(0,4);
    switch ($fsk)
    {
        case 0: $fsk = 0;break;
        case 1: $fsk = 6;break;
        case 2: $fsk = 12;break;
        case 3: $fsk = 16;break;
        case 4: $fsk = 18;break;
    }
	
	$istTopfilm = rand(1,4);
	if ( $istTopfilm < 4 )
		$istTopfilm = 0;
	else
		$istTopfilm = 1;
    
    $zufallCol = rand(1,3);
    $inhalt = "Hier steht der Informationstext zum Film. Dieser erkl&auml;rt, worum es in diesem Film geht. Einen solchen Text kann man &uuml;berall rauskopieren. Vorher habe ich f&uuml;r diese Demoinstallation die Text- und Bildinformationen von www.invdeo.de benutzt. Aber bevor ich &Auml;rger mit Urheberrechten bekomme, habe ich mich f&uuml;r diese Zufallsinformationen enscheiden. Ich muss noch bissel Text schreiben, sonst sieht das hier so alleine aus und da sieht das dann nicht sehr sch&ouml;n aus...";
    $bemerkung = "Hier k&ouml;nnte stehen, ob der Film s/w ist oder in welcher Sprache oder, oder, oder, ...";
    
    switch (rand(0,64))
    {
        case  0: $letter="a";break;
        case  1: $letter="b";break;
        case  2: $letter="c";break;
        case  3: $letter="d";break;
        case  4: $letter="e";break;
        case  5: $letter="f";break;
        case  6: $letter="g";break;
        case  7: $letter="h";break;
        case  8: $letter="i";break;
        case  9: $letter="j";break;
        case 10: $letter="k";break;
        case 11: $letter="l";break;
        case 12: $letter="m";break;
        case 13: $letter="n";break;
        case 14: $letter="o";break;
        case 15: $letter="p";break;
        case 16: $letter="q";break;
        case 17: $letter="r";break;
        case 18: $letter="s";break;
        case 19: $letter="t";break;
        case 20: $letter="u";break;
        case 21: $letter="v";break;
        case 22: $letter="w";break;
        case 23: $letter="x";break;
        case 24: $letter="y";break;
        case 25: $letter="z";break;
        case 26: $letter="A";break;
        case 27: $letter="B";break;
        case 28: $letter="C";break;
        case 29: $letter="D";break;
        case 30: $letter="E";break;
        case 31: $letter="F";break;
        case 32: $letter="G";break;
        case 33: $letter="H";break;
        case 34: $letter="I";break;
        case 35: $letter="J";break;
        case 36: $letter="K";break;
        case 37: $letter="L";break;
        case 38: $letter="M";break;
        case 39: $letter="N";break;
        case 40: $letter="O";break;
        case 41: $letter="P";break;
        case 42: $letter="Q";break;
        case 43: $letter="R";break;
        case 44: $letter="S";break;
        case 45: $letter="T";break;
        case 46: $letter="U";break;
        case 47: $letter="V";break;
        case 48: $letter="W";break;
        case 49: $letter="X";break;
        case 50: $letter="Y";break;
        case 51: $letter="Z";break;
        case 52: $letter="1";break;
        case 53: $letter="2";break;
        case 54: $letter="3";break;
        case 55: $letter="4";break;
        case 56: $letter="5";break;
        case 57: $letter="6";break;
        case 58: $letter="7";break;
        case 59: $letter="8";break;
        case 60: $letter="9";break;
        case 61: $letter="&quot;";break;
        case 62: $letter="(";break;
        case 63: $letter=")";break;
        case 64: $letter="!";break;
        
        default: $letter="a";
    }
    $titel = "$letter Ich bin ein Titel mit Zufallanfangsbuchstabe ".getAnzStellenID($i,$settings);
    
    $sql = "INSERT INTO $myDB->FILME (Titel,COLLECT_CollectID,FORMATE_FormatID,Jahr,Land,Inhalt,FSK,Laufzeit,Bemerkung,istTopfilm,inserted,USERS_UserID) VALUES (" .
            " '$titel',$zufallCol,".rand(1,3).",".rand(1980,2005).",'irgendwo','$inhalt',$fsk,".rand(80,160).",'$bemerkung',$istTopfilm,NOW(), 1 )";
    $myDB->go($sql);
    $FilmID = mysql_insert_id();
    
    // Cover kopieren
    $anzCovers = rand(1,2);
    for ( $j=1; $j<=$anzCovers; ++$j )
    {
        $appendix = substr( gen_string(), 0, 10 );
        
        // Bildappendix und Format in der DaBa speichern
        $sql = "INSERT INTO $myDB->COVERS (FILME_FilmID,Rang,Appendix,Extension) VALUES ($FilmID,$j,'$appendix','jpg')";
        $rs = $myDB->go($sql);
        
        $sql = "SELECT FILME_FilmID FROM $myDB->COVERS WHERE FILME_FilmID=$FilmID AND Rang=$j";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        $longFilmID = $row['FILME_FilmID'];
        
        $fromCover = "./reset_cover.jpg";// $covers."/".$oldFilmID."_".$row['Bildappendix'].".".$row['Bildformat'];
        $toCover = "../covers/".$longFilmID."_".$j."_".$appendix."."."jpg";
        copy( $fromCover, $toCover );
        
        if ( $j == 1 )
            echo thumbnail($longFilmID, 1, $appendix, 'jpg', $myDB);
    }
    
    
    // myFilmID richtig setzen
    $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME WHERE COLLECT_CollectID=$zufallCol GROUP BY COLLECT_CollectID";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    $myFilmID = (int) $row['Anz'];
    $sql = "UPDATE $myDB->FILME SET myFilmID=$myFilmID WHERE FilmID=$FilmID";
    $myDB->go($sql);
    
    // Schauspieler fr den Film setzen
    $anz = rand(3, 18);
    unset($array);
    $array = array();
    for ( $j=1; $j<=$anz; ++$j )
    {
        $ActorID = rand(1,$anzActors);
        if ( !in_array($ActorID,$array) )
            $array[] = $ActorID;
    }
    
    for ( $j=1; $j<count($array); ++$j )
    {
        $sql = "INSERT INTO $myDB->FILME_ACTORS VALUES($i,{$array[$j]},$j)";
        $myDB->go($sql);
    }
    
    
    // Regisseur(e) fr den Film setzen
    $anz = rand(1, 2);
    unset($array);
    $array = array();
    $regie = "";
    for ( $j=1; $j<=$anz; ++$j )
    {
        $regID = rand(1,$anzActors);
        if ( !in_array($regID,$array) )
        {
            $array[] = $regID;
            $sql = "SELECT Name FROM $myDB->ACTORS WHERE ActorID=$regID";
            $rs = $myDB->go($sql);
            $row = $myDB->getRow($rs);
        }
        if ( strlen($regie) )
            $regie .= ", ";
        $regie .= $row['Name'];
    }
    
    $regie = explode( ",", $regie );
    // fr jeden Teil Leerzeichen entfernen und HTML-Entities ersetzen
    for ( $j = 0; $j < count($regie); ++$j )
        $regie[$j] = $myDB->escape_string( $regie[$j] );
    
    $regiesNameID = getArrayNameID( $regie, "Regisseure", $myDB );
    insertIntoRelation( $regiesNameID, "Regisseure", $i, $myDB );
    
    
    // Genres einfgen
    $anzGen = rand(1,4);
    unset($GenreArray);
    $GenreArray = array();
    for ( $j=1; $j<=$anzGen; ++$j )
    {
        $genreID = rand( 1,count($GenArray) );
        if ( !in_array($genreID,$GenreArray) )
            $GenreArray[] = $genreID;
    }
    insertIntoRelation( $GenreArray, "Genre", $i, $myDB );
    
    
    // DiscID eintragen
    $anzDisks = rand(1,3);
    $sql = "SELECT di.DiscID FROM $myDB->DISCS di INNER JOIN $myDB->FILME fi ON di.FILME_FilmID = fi.FilmID WHERE fi.COLLECT_CollectID = $zufallCol ORDER BY DiscID ASC";
    $rs = $myDB->go($sql);
    $oldID = 1;
    $check = FALSE;
    
    // es wird gesucht, wo anzDisks hintereinander frei sind
    while ( $row = $myDB->getRow($rs) )
        if ( $oldID < $row['DiscID'] || $check )
        {
            // am Anfang markieren, dass freie DiscID gefunden wurde
            if ( !$check )
                $check = TRUE;
            // wenn Differenz von nchste belegte ID und gemerkte freie ID >= Anzahl ist, dann ID gefunden
            elseif ( $row['DiscID']-$oldID > $anzDisks )
                    break;
            // ansonsten Markierung rckgngig machen
            else
            {
                $check = FALSE;
                $oldID = $row2['DiscID'] + 1;
            }
        }
        else
            ++$oldID;
        
    $DiscID = $oldID;
    
    for ( $j = 0; $j < $anzDisks; ++$j )
    {
        $id = $DiscID+$j;
        $sql = "INSERT INTO $myDB->DISCS (DiscID,FILME_FilmID) VALUES ($id,$FilmID)";
        $myDB->go($sql);
    }
}



// gesehene Filme eintragen
$sql = "SELECT UserID FROM $myDB->USERS";
$rs = $myDB->go($sql);
while ( $row = $myDB->getRow($rs) )
{
    // array mit gesehenen FilmID's erstellen
    $anzGesehen = (int) $anzFilme / 3;
    unset($array);
    $array = array();
    for ( $j=1; $j<=$anzGesehen; ++$j )
    {
        $FilmID = rand(1,$anzFilme);
        if ( !in_array($FilmID,$array) )
            $array[] = $FilmID;
    }
    
    // Eintrag machen
    for ( $j=0;  $j<count($array); ++$j )
    {
        $sql2 = "INSERT INTO $myDB->FILME_USERS VALUES ({$array[$j]},{$row['UserID']},'Ich bin ein tolles Zufallskommentar',".rand(0,1).",0,NOW(),".rand(1,10).")";
        $myDB->go($sql2);
    }
}


// ausgeliehene Filme eintragen
$sql = "SELECT UserID FROM $myDB->USERS WHERE UserID > 1";
$rs = $myDB->go($sql);
while ( $row = $myDB->getRow($rs) )
{
    // array mit gesehenen FilmID's erstellen
    $verliehene = rand(0,2);
    unset($array);
    $array = array();
    for ( $j=1; $j<=$verliehene; ++$j )
    {
        $FilmID = rand(1,$anzFilme);
        if ( !in_array($FilmID,$array) )
            $array[] = $FilmID;
    }
    
    // Eintrag machen
    for ( $j=0;  $j<count($array); ++$j )
    {
        $sql2 = "UPDATE $myDB->DISCS SET USERS_UserID={$row['UserID']}, ausgeliehenAm=NOW() WHERE FILME_FilmID={$array[$j]}"; 
        $myDB->go($sql2);
    }
}

}
















/*
 * Erzeuge ein Thumbnail zu einem gegebenen Film
 */
function thumbnail( $FilmID, $Rang, $Appendix, $Extension, $myDB )
{
    // gewnschte Hhe
    $dest_h = 100;
    // gewnschte Breite
    $dest_w  = 75;
    
    $ratio = $dest_h / $dest_w;
    
    $src_img = "../covers/{$FilmID}_{$Rang}_{$Appendix}.{$Extension}";
    //$mime = mime_content_type($src_img);
    //$type = substr($mime, strpos($mime,'/')+1);
    
    // etwas unschn fr die Ermittlung des Formats, aber es wurde beim Hochladen schon geprft...
    switch($Extension) {
        case 'jpeg': case 'pjpeg': case 'jpg':
            $image = imagecreatefromjpeg($src_img);
            break;
        case 'png': case 'x-png':
            $image = imagecreatefrompng($src_img);
            break;
        case 'gif':
            $image = imagecreatefromgif($src_img);
            break;
        default:
            return("Zu diesem Bildformat kann kein Thumbnail erstellt werden!");
    }
    
    $dest_img = "../covers/{$FilmID}_{$Rang}_{$Appendix}_small.{$Extension}";
    $src_size = getimagesize($src_img);
                        
    // verkleinertes Cover muss proportional bleiben
    // wenn das Bild breiter ist...
    if ( $src_size[1]/$src_size[0] < $ratio )
    {
        $off_y = 0;
        $off_x = (int)( $src_size[0] - $src_size[1]/$ratio ) / 2;
        $src_size[0] = (int)$src_size[1]/$ratio;
    }
    // wenn das Bild hher ist...
    elseif ( $src_size[1]/$src_size[0] > $ratio )
    {
        $off_y = (int)( $src_size[1] - $src_size[0]*$ratio ) / 2;
        $off_x = 0;
        $src_size[1] = (int)$src_size[0]*$ratio;
    }
    // wenn Bild genau im Verhltnis ist
    else
    {
        $off_y = 0;
        $off_x = 0;
    }
    
    $image_p = imagecreatetruecolor($dest_w,$dest_h);
    $ret = imagecopyresampled( $image_p, $image,0,0,$off_x,$off_y, $dest_w, $dest_h, $src_size[0],$src_size[1]  );
    
    // Wenn Fehler aufgetreten, dann zurck
    if ( !$ret )
        return("Fehler beim Erstellen eines Thumbnails!");
    
    
    switch($Extension) {
        case 'jpeg': case 'pjpeg': case 'jpg':
            imagejpeg($image_p, $dest_img, 100);
            break;
        case 'png': case 'x-png':
            imagepng($image_p, $dest_img);
            break;
        case 'gif':
            imagegif($image_p, $dest_img);
            break;
        default:
            return("Mit dem Thumbnail stimmt etwas nicht!");
    }
    
    // nderung muss gespeichert werden
    $sql = "UPDATE $myDB->COVERS SET hatThumbnail=1 WHERE FILME_FilmID=$FilmID AND Rang=$Rang";
    $myDB->go($sql);
    
    return;
}


?>
